#! /bin/sh
### BEGIN INIT INFO
# Provides:          istgt
# Required-Start:    $network $local_fs $remote_fs
# Required-Stop:     $remote_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: iSCSI userspace target for kFreeBSD systems
# Description:       iSCSI userspace target for kFreeBSD systems
### END INIT INFO

# Author: Arno Töll <debian@toell.net>

PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="istgt iSCSI target"
NAME=istgt
DAEMON=/usr/sbin/istgt
ISTGTCONTROL=/usr/sbin/istgtcontrol
PIDFILE=/var/run/$NAME.pid
DAEMON_ARGS="-c /etc/istgt/istgt.conf -p $PIDFILE"
SCRIPTNAME=/etc/init.d/$NAME
CONFIG=/etc/istgt/istgt.conf

# Exit if the package is not installed
[ -x $DAEMON ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

if [ ! -r $CONFIG ] ; then
	[ "$VERBOSE" != no ] && log_warning_msg "Not Starting $DESC: $CONFIG does not exit"
	exit 0
fi

#
# Function that starts the daemon/service
#
do_start()
{
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
		|| return 1
	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
		$DAEMON_ARGS  2>&1 | logger -p daemon.info \
		|| return 2

	RETVAL=0
	for i in 1 2 3 4 5 ; do
		sleep 1
		pidofproc -p $PIDFILE "$DAEMON" "$NAME" > /dev/null || RETVAL=$?
		[ "$RETVAL" = 0 ] && return 0
	done

	[ "$RETVAL" != 0 ] && return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
	[ "$?" = 2 ] && return 2
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
	[ -x $ISTGTCONTROL ] || return 127
	pidofproc -p $PIDFILE $NAME > /dev/null || return 2
	$ISTGTCONTROL refresh > /dev/null 2>&1
	return $?
}

case "$1" in
  start)
    [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
    do_start
    case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
  ;;
  stop)
	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
	do_stop
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  reload)
    [ "$VERBOSE" != no ] && log_daemon_msg "Reloading $DESC " "$NAME"
    do_reload
    case "$?" in
		0)
			[ "$VERBOSE" != no ] && log_end_msg 0
			;;
		2)
			[ "$VERBOSE" != no ] && log_end_msg 1
			[ "$VERBOSE" != no ] && log_warning_msg "$NAME is not running"
			;;
		127)
			[ "$VERBOSE" != no ] && log_end_msg 1
			[ "$VERBOSE" != no ] && log_warning_msg "$ISTGTCONTROL not found"
			;;
		*)
			[ "$VERBOSE" != no ] && log_end_msg 1
			;;
	esac
  ;;
  status)
       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
       ;;
  restart)
	log_daemon_msg "Restarting $DESC" "$NAME"
	do_stop
	case "$?" in
	  0|1)
		do_start
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
	  	# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  *)
	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
	exit 3
	;;
esac

:
